import { $sharePathAddQuery } from '@coolban/wx-utils';

export default {
  data: {
    has_init_share: false
  },
  uData: {
    share_info: {}
  },
  onLoad() {
    if (!this.config || !this.config.disable_init_share_info) {
      // CONDI: 如果没有config 或者 不禁止加载 => 配置分享
      this._initShare(this.config.origin);
    }
  },
  methods: {
    async _initShare(o = '', params = {}) {
      const { delay, disable_delay } = params;

      wx.hideShareMenu();

      // STEP: 延迟加载
      if (!disable_delay) {
        await this.$sleep(delay >= 0 ? delay : 1 * 1000);
        if (!this.$route.isExist) {
          return Promise.resolve();
        }
      }

      // STEP: 保存信息
      this.uData.share_info = await this.getDefaultShareInfo(false, {
        o
      });
      this.setData({
        has_init_share: true
      });

      // STEP: 显示分享
      wx.showShareMenu();
      return Promise.resolve();
    },
    _shareInfoHandle(e) {
      const { from, target } = e;
      let _shareInfo = {};

      if (this.uData.share_info_other && this.uData.share_info_other.path) {
        _shareInfo = this.uData.share_info_other;
      } else if (this.uData.share_info.path) {
        _shareInfo = JSON.parse(JSON.stringify(this.uData.share_info));
        let _path = _shareInfo.path;
        if (from === 'button') {
          if (target.dataset.addQuery) {
            _path = $sharePathAddQuery(
              _shareInfo.path,
              target.dataset.addQuery
            );
          } else if (target.dataset.shareConf) {
            let { origin, withShareRankId } = target.dataset.shareConf;
            origin = origin !== void 0 ? origin : this.config.origin;
            _path = $sharePathAddQuery(_shareInfo.path, {
              key: 'o',
              value: [
                withShareRankId ? `rand_${_shareInfo.id}` : '',
                withShareRankId && origin ? '|' : '',
                origin
              ].join('')
            });
          }
        }

        _shareInfo.path = _path;
      } else {
        // CONDI: 提示分享正在配置
        wx.showModal({
          content: '分享配置中，请稍候尝试',
          showCancel: false,
          confirmText: '确定',
          confirmColor: '#3CC51F'
        });
      }

      // STEP: 删除无用信息
      _shareInfo = JSON.parse(JSON.stringify(_shareInfo));
      delete _shareInfo.share_card_ids;
      delete _shareInfo.id;

      return _shareInfo;
    }
  }
};
